/* websour.ll {{{1

* @progname	websour
* @version 	1.0.0 (05/01/2010)
* @author 	Patrick Texier (p.texier@orsennes.org)
* @category
* @output 	HTML
* @description

	Liste des sources correspondant à des sites Web.

	}}}1 */
char_encoding("UTF-8")
/* Déclarations {{{1 */
global(auteur)
global(publ)
global(titre)
global(cle)
global(gw)
global(liste_gw)
global(liste_autres)
global(une_ligne)
/* }}}1 */
proc main () /* {{{1 */
{
	/* Il n'y a pas de sélection : le nom du fichier de sortie peut être dans init() */
	call init()
	call header()
	forsour(noeud, cpt) {
		set(auteur, "")
		set(publ, "")
		set(titre, "")
		set(gw, 0)
		set(cle, key(noeud))
		traverse(noeud, noeud2, cpt2) {
			if(eqstr(tag(noeud2), "TITL")) {
				set(titre, value(noeud2))
			}
			elsif(eqstr(tag(noeud2), "AUTH")) {
				set(auteur, value(noeud2))
			}
			elsif(eqstr(tag(noeud2), "PUBL")) {
				set(publ, value(noeud2))
			}
		}
		if(eqstr(substring(publ, 1, 5), "http:")) {
			call test_gw()
			call maj_liste()
		}
	}
	sort(liste_gw)
	sort(liste_autres)
	print("Sources web trouvées : \n\n")
	print("Bases GeneWeb : ")
	print(d(length(liste_gw)))
	print(nl())
	print("Autres : ")
	print(d(length(liste_autres)))
	print(nl())
	if(length(liste_gw)) {
		call aff_liste(liste_gw, 1)
	}
	if(length(liste_autres)) {
		call aff_liste(liste_autres, 2)
	}
	call footer()
} /* }}}1 */
proc init() /* {{{1 */
{
	if(1) {
		newfile("sources.html", 0)
	}
	list(liste_gw)
	list(liste_autres)
	list(une_ligne)
} /* }}}1 */
proc test_gw() /* {{{1 */
{
	if(index(publ, "gw.geneanet.org", 1)) {
		set(gw, 1)
	}
	elsif(index(lower(titre), "geneweb", 1)) {
		set(gw, 1)
	}
	else {
		set(gw, 0)
	}
} /* }}}1 */
proc maj_liste() /* {{{1 */
{
	set (trav, concat(auteur,"\t", titre, "\t", publ, "\t", cle))
	if(gw) {
		push(liste_gw, trav)
	}
	else {
		push(liste_autres, trav)
	}
} /* }}}1 */
proc aff_liste(varl, param) /* {{{1 */
{
	if(eq(param, 1)) {
		"<li>Liste des " d(length(liste_gw)) " bases GeneWeb\n"
	}
	else {
		"<li>Liste des " d(length(liste_autres)) " autres sites internet\n"
	}
	"<ul>\n"
	forlist(varl, ligne, bidon) {
		call aff_ligne(ligne)
	}
	"</ul>\n"
} /* }}}1 */
proc aff_ligne(ligne) /* {{{1 */
{
	extracttokens(ligne, une_ligne, bidon, "\t")
	set(auteur, dequeue(une_ligne))
	set(titre, dequeue(une_ligne))
	set(url, dequeue(une_ligne))
	set(cle, dequeue(une_ligne))
	"<li>"
	if(nestr(auteur, "")) {
		"<b>" auteur ".</b> "
	}
	if(nestr(titre, "")) {
		"<i>" titre ".</i> "
	}
	"<a href=" qt() url qt() ">" url "</a>. <font size=-1>[" cle "]</font>\n"
} /* }}}1 */
proc header() /* {{{1 */
{

	"<!DOCTYPE HTML PUBLIC " qt() "-//W3C//DTD HTML 4.01 Transitional//EN" qt() ">"
	"<html>\n"
	"<head>\n"
	"<meta http-equiv=" qt() "Content-Type " qt() "content=" qt()"text/html; charset=utf-8" qt() ">\n"
	"<title>Sources de la base LifeLines " database() "</title>\n"
	"</head>\n"
	"<body>\n"
	"<h1>Sources de la base LifeLines " database() "</h1>\n"
	"<hr>\n"
	"<ul>\n"
} /* }}}1 */
proc footer() /* {{{1 */
{
	"</ul>\n"
	"<hr>\n"
	"<p>Page générée par websour.ll un rapport LifeLines écrit par Patrick Texier</p>\n"
	"</body>\n"
	"</html>\n"
} /* }}}1 */
/*
 vim:fdm=marker
*/
